searchData={"items":[{"type":"module","title":"Optimal","doc":"Documentation for Optimal.","ref":"Optimal.html"},{"type":"function","title":"Optimal.document/1","doc":"See  Optimal.Doc.document/1 .","ref":"Optimal.html#document/1"},{"type":"function","title":"Optimal.document/2","doc":"See `Optimal.Doc.document/2`","ref":"Optimal.html#document/2"},{"type":"type","title":"Optimal.error/0","doc":"","ref":"Optimal.html#t:error/0"},{"type":"function","title":"Optimal.merge/2","doc":"See `Optimal.Schema.merge/2`","ref":"Optimal.html#merge/2"},{"type":"function","title":"Optimal.merge/3","doc":"See  Optimal.Schema.merge/3 .","ref":"Optimal.html#merge/3"},{"type":"function","title":"Optimal.schema/0","doc":"See  Optimal.Schema.new/0 .","ref":"Optimal.html#schema/0"},{"type":"type","title":"Optimal.schema/0","doc":"","ref":"Optimal.html#t:schema/0"},{"type":"function","title":"Optimal.schema/1","doc":"See `Optimal.Schema.new/1`","ref":"Optimal.html#schema/1"},{"type":"function","title":"Optimal.validate/2","doc":"","ref":"Optimal.html#validate/2"},{"type":"function","title":"Optimal.validate!/2","doc":"Validates opts according to a schema or the constructor for a schema. Raises on invalid opts.\n\n    iex> Optimal.validate!([reticulate_splines?: true], opts: [:reticulate_splines?])\n    [reticulate_splines?: true]\n    iex> Optimal.validate!([reticulate_splines?: true], opts: [:load_textures?], extra_keys?: true)\n    [reticulate_splines?: true]\n    iex> schema = Optimal.schema(opts: [:reticulate_splines?], required: [:reticulate_splines?], extra_keys?: true)\n    ...> Optimal.validate!([reticulate_splines?: true, hack_interwebs?: true], schema)\n    [reticulate_splines?: true, hack_interwebs?: true]\n    iex> Optimal.validate!([], opts: [:reticulate_splines?], required: [:reticulate_splines?])\n    ** (ArgumentError) Opt Validation Error: reticulate_splines? - is required","ref":"Optimal.html#validate!/2"},{"type":"type","title":"Optimal.validation_result/0","doc":"","ref":"Optimal.html#t:validation_result/0"},{"type":"module","title":"Optimal.Doc","doc":"Automatic opt documentation, to be placed into your function docstrings","ref":"Optimal.Doc.html"},{"type":"function","title":"Optimal.Doc.document/2","doc":"---","ref":"Optimal.Doc.html#document/2"},{"type":"function","title":"Opts - Optimal.Doc.document/2","doc":"* `name`(`:string`): The top level header for the opts documentation - Default: \"Opts\"\n* `header_depth`(`:int`): How many `#` to prepend before any heading - Default: 1\n\n---","ref":"Optimal.Doc.html#document/2-opts"},{"type":"module","title":"Optimal.Schema","doc":"Functions for generating and validating the opts that generate a schema.","ref":"Optimal.Schema.html"},{"type":"function","title":"Optimal.Schema.merge/3","doc":"Merges two optimal schemas to create a superset schema.\n\n---","ref":"Optimal.Schema.html#merge/3"},{"type":"function","title":"Opts - Optimal.Schema.merge/3","doc":"* `annotate`(`:string`): Annotates the source of the opt, to be used in displaying documentation.\n* `add_required?`(`:boolean`): \"If true, all required fields from left/right are marked as required. Otherwise, only takes required fields from the left.\"\n\n---","ref":"Optimal.Schema.html#merge/3-opts"},{"type":"function","title":"Optimal.Schema.new/0","doc":"Create a new schema.\n\n---","ref":"Optimal.Schema.html#new/0"},{"type":"function","title":"Opts - Optimal.Schema.new/0","doc":"* `opts`(`[{:list, :atom}, :keyword]`): A list of opts accepted, or a keyword of opt name to opt type - Default: []\n* `required`(`{:list, :atom}`): A list of required opts (all of which must be in `opts` as well) - Default: []\n* `defaults`(`:keyword`): A keyword list of option name to a default value. Values must pass type rules - Default: []\n* `extra_keys?`(`:boolean`): If enabled, extra keys not specified by the schema do not fail validation - Default: false\n* `custom`(`:keyword`): A keyword list of option name (for errors) and custom validations. See README - Default: []\n* `describe`(`:keyword`): A keyword list of option names to short descriptions (like these) - Default: []\n\n---\n\nA custom validation is run on the types provided at schema creation time, to ensure they are all valid types.","ref":"Optimal.Schema.html#new/0-opts"},{"type":"function","title":"Optimal.Schema.new/1","doc":"","ref":"Optimal.Schema.html#new/1"},{"type":"type","title":"Optimal.Schema.t/0","doc":"","ref":"Optimal.Schema.html#t:t/0"},{"type":"module","title":"Optimal.SchemaHelpers","doc":"Helpers for building and working with schemas.","ref":"Optimal.SchemaHelpers.html"},{"type":"function","title":"Optimal.SchemaHelpers.merge_schema/0","doc":"The schema of the opts for merging two optimal schemas","ref":"Optimal.SchemaHelpers.html#merge_schema/0"},{"type":"function","title":"Optimal.SchemaHelpers.schema_schema/0","doc":"The schema of the opts for making an Optimal schema.","ref":"Optimal.SchemaHelpers.html#schema_schema/0"},{"type":"module","title":"Optimal.Type","doc":"Exposes functions for validating types, and determining if a value matches a type.","ref":"Optimal.Type.html"},{"type":"function","title":"Optimal.Type.matches_type?/2","doc":"","ref":"Optimal.Type.html#matches_type?/2"},{"type":"function","title":"Optimal.Type.merge/2","doc":"","ref":"Optimal.Type.html#merge/2"},{"type":"function","title":"Optimal.Type.valid_type?/1","doc":"","ref":"Optimal.Type.html#valid_type?/1"},{"type":"function","title":"Optimal.Type.validate_types/4","doc":"","ref":"Optimal.Type.html#validate_types/4"},{"type":"extras","title":"Optimal","doc":"# Optimal\n\nOptimal is a schema based `opt` validator. It is verbose, but I've tried many other data validation libraries, and their succinctness came with a cost when it came to features. There are still a lot of optimizations and improvements that can be made, so contributions are very welcome.\n\nThis `opt` validator has a bit of a niche. It fits in just fine with validating any keyword list, but its especially useful for validating compile-time options, like ones provided to functions in a DSL.\n\nView the documentation: [https://hexdocs.pm/optimal](https://hexdocs.pm/optimal)","ref":"readme.html"},{"type":"extras","title":"Roadmap - Optimal","doc":"* Better error messages, both for type mismatches and in general\n* Optimize. The schema based design allows schemas to be declared at compile time (for instance in module attributes) and that should be leveraged as much as possible to ensure that validating a schema does no work that could be done when building the schema.\n* Macro. We could potentially provide something that can partially validate opts at compile time. For instance, any literal values or known values could be validated at compile time.","ref":"readme.html#roadmap"},{"type":"extras","title":"Installation - Optimal","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `optimal` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:optimal, \"~> 0.3.6\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Getting Started - Optimal","doc":"","ref":"readme.html#getting-started"},{"type":"extras","title":"Validation Examples - Optimal","doc":"To use Optimal, you define your validation rules as an Optimal schema and then validate input against it using the `Optimal.validate/2` or `Optimal.validate!/2` functions.\n \nValidate a keyword list:\n```elixir\niex> schema = Optimal.schema(opts: [:foo, :bar, :baz])\niex> my_list = [{:foo, \"foo val\"}, {:bar, \"bar val\"}, {:baz, \"bazz val\"}]\niex> Optimal.validate(my_list, schema)\n{:ok, [foo: \"foo val\", bar: \"bar val\", baz: \"bazz val\"]}\n```\n\nOr validate a map:\n\n```elixir\niex> my_map = %{foo: \"foo val\", bar: \"bar val\", baz: \"bazz val\"}\n%{bar: \"bar val\", baz: \"bazz val\", foo: \"foo val\"}\niex> Optimal.validate(my_map, schema)\n{:ok, [bar: \"bar val\", baz: \"bazz val\", foo: \"foo val\"]}\n```\n\nNotice that in both cases, a keyword list is returned.\n\nUse `Optimal.validate!/2` to return an error instead of a tuple:\n```elixir\niex> bad_map = %{d: \"not allowed\"}\n%{other: \"stuff\"}\niex> schema = Optimal.schema(opts: [:a, :b, :c])\niex> Optimal.validate!(bad_map, schema)\n** (ArgumentError) Opt Validation Error: other - is not allowed (no extra keys)\n    (optimal) lib/optimal.ex:44: Optimal.validate!/2\n```\n\nYou can require that your inputs be of a certain type:\n\n```elixir\niex> schema = Optimal.schema(opts: [age: :int, name: :string])\niex> my_data = [{:age, 12}, {:name, false}]\niex> Optimal.validate(my_data, schema)\n{:error, [name: \"must be of type :string\"]}\n```","ref":"readme.html#validation-examples"},{"type":"extras","title":"Schema Examples - Optimal","doc":"Define your validation rules in your schema.\n\n```elixir\n# Allow no opts\nOptimal.schema()\n\n# Allow any opts\nOptimal.schema(extra_keys?: true)\n\n# Allow a specific set of opts\nOptimal.schema(opts: [:foo, :bar, :baz])\n\n# Allow specific types\nOptimal.schema(opts: [foo: :int, bar: :string, baz: :pid])\n\n# Require certain opts\nOptimal.schema(opts: [foo: :int, bar: :string, baz: :pid], required: [:foo, :bar])\n\n# Provide defaults for arguments (defaults will have to pass any type validation)\n# If they provide they key, but a `nil` value, the default is *not* used.\nOptimal.schema(opts: [foo: :int, bar: :string, baz: :boolean], defaults: [baz: true])\n\n# Allow only specific values for certain opts\nOptimal.schema(opts: [foo: {:enum, [1, 2, 3]}])\n\n# Custom validations\n# Read below for more info\ndef custom(field_value, field_name, all_opts, schema) do\n  if is_special(field_value) do\n    :ok\n  else\n    [{field_name, \"must be special\"}]\n  end\nend\n\nOptimal.schema(opts: [foo: :integer, bar: :string], custom: [bar: &custom/4])\n```","ref":"readme.html#schema-examples"},{"type":"extras","title":"Types - Optimal","doc":"","ref":"readme.html#types"},{"type":"extras","title":"Scalar Types - Optimal","doc":"* :any\n* :atom\n* :binary\n* :bitstring\n* :boolean\n* :float\n* :function\n* :int\n* :integer\n* :keyword\n* :list\n* :string\n* :map\n* :nil\n* :number\n* :pid\n* :port\n* :reference\n* :tuple\n* :struct","ref":"readme.html#scalar-types"},{"type":"extras","title":"Composite/Complex Types - Optimal","doc":"* `{:keyword, value_type}` - Keyword where all values are of type `value_type`\n* `{:list, value_type}` - List where all values are of type `value_type`\n* `{:function, arity}` - A function with the arity given by `arity`\n* `{:struct, Some.Struct`} - An instance of `Some.Struct`\n* `%Some.Struct{}` - Same as `{:struct, Some.Struct}`\n* `{:enum, [value1, value2]}` - Allows any value in the list.\n* `{:tuple, tuple_size}` - Tuple with size `tuple_size`.\n* `{:tuple, {type1, type2, ...}}` - Tuple with given type structure, so the first element is of type `type1`, etc.\n* `{:tuple, tuple_size, value_type}` - Tuple with size `tuple_size` and every element of type `value_type`.\n* A nested optimal schema - Will validate that the provided keyword list adheres to the schema.","ref":"readme.html#composite-complex-types"},{"type":"extras","title":"Custom Validations - Optimal","doc":"Your custom validators are defined as keyword list added to the `custom:` atom, e.g.\n\n```elixir\nOptimal.schema(opts: [foo: :integer, bar: :string], custom: [bar: &my_custom_validator/4])\n```\n\nCustom validations have the ability to add arbitrary errors and can modify the `opts` as they pass through. They are run in order, and unlike all built in validations, they are only run on valid opts. In other words, the custom validators run _after_ the other validators.\n\nYour custom validation functions should receive 4 arguments:\n \n* field value\n* field id (atom)\n* options\n* schema\n\nAnd they may return several different types of responses:\n\n* `true` / `false` to indicate whether it passed or failed validation\n* `:ok` to indicate that it passed validation\n* `{:ok, updated_options}` to provide modifications to the options before output\n* `{:error, error_or_errors}` to provide a custom message(s) about a failed validation\n* `[]` to indicate that it passed validation\n* a list of errors to indicate why it failed validation","ref":"readme.html#custom-validations"},{"type":"extras","title":"Custom Validator Usage Example - Optimal","doc":"Because custom validators can modify the `opts`, we can change the final output to a map (arbitrarily, this validation rule is attached to the `c` field):\n\n```elixir\niex> my_data = [{:a, \"Apple\"}, {:b, \"Boy\"}, {:c, \"Cat\"}]\niex> schema = Optimal.schema(opts: [a: :string, b: :string, c: :string], custom: [c: fn _, _, opts, _ -> {:ok, Enum.into(opts, %{})} end])\niex> Optimal.validate(my_data, schema)                                      \n{:ok, %{a: \"Apple\", b: \"Boy\", c: \"Cat\"}\n```","ref":"readme.html#custom-validator-usage-example"},{"type":"extras","title":"Custom Validation Function Examples - Optimal","doc":"```elixir\n# Simple (returning booleans)\ndef is_ten(field_value, _, _, _) do\n  field_value == 10\nend\n\n# Custom errors (ok/error tuples)\ndef is_ten(field_value, field, _, _) do\n  if field_value == 10 do\n    :ok\n  else\n    {:error, {field, \"should really have equaled ten\"}}\n  end\nend\n\n# Returning a list of errors\ndef greater_than_1_and_even(field_value, field, _, _) do\n  errors =\n    if field_value > 1 do\n      []\n    else\n      [{field, \"should be greater than 1\"}]\n    end\n\n  if Integer.is_even(field_value) do\n    errors\n  else\n    [{field, \"should be even\"} | errors]\n  end\nend\n```","ref":"readme.html#custom-validation-function-examples"},{"type":"extras","title":"Auto Documentation - Optimal","doc":"If your schemas are defined at compile time, it is possible to interpolate a generated documentation for them into your docstrings.\nIf you are doing this, you may also want to leverage the `describe` opt when building schemas, that lets you attach descriptions.\n\nFor example:\n\n```elixir\n\n@opts Optimal.schema(opts: [\n    foo: [:int, :string],\n    bars: {:list, :int}\n  ],\n  required: [:foo],\n  describe: [\n    foo: \"The id of the foo you want\",\n    bars: \"The ids of all of the bars you want\"\n  ],\n  defaults: [\n    bars: []\n  ],\n  extra_keys?: true\n)\n\n@doc \"\"\"\nThis does a special thing.\n\n#{Optimal.Doc.document(@opts)}\n\nMore in-depth documentation\n\"\"\"\ndef my_special_function(opts) do\n\nend\n```\n\nThis would generate a docstring that looks like:","ref":"readme.html#auto-documentation"},{"type":"extras","title":"Doc Example - Optimal","doc":"This does a special thing.\n\n---","ref":"readme.html#doc-example"},{"type":"extras","title":"Opts - Optimal","doc":"* `foo`(`[:int, :string]`) **Required**: The id of the foo you want\n* `bars`(`{:list, :int}`): The ids of all of the bars you want - Default: []\n\nAlso accepts extra opts that are not named here.\n\n---\n\nMore in-depth documentation","ref":"readme.html#opts"},{"type":"extras","title":"Schema merging - Optimal","doc":"This behavior is not set in stone, and will probably need to take a `strategy` option to support different kinds of merging opt schemas. This is very useful when working with many functions that are more specific versions of some generic action, or that all eventually call into the same function and need to accept that function's opts as well.\n\n```elixir\n\nschema1 = Optimal.schema(opts: [foo: :int])\nschema2 = Optimal.schema(opts: [foo: :string, bar: :int])\n\nOptimal.merge(schema1, schema2) == Optimal.schema(opts: [foo: [:int, :string], bar: :int])\n```","ref":"readme.html#schema-merging"},{"type":"extras","title":"Merge annotations - Optimal","doc":"You can provide an annotation when merging, and options will be further grouped by that annotation.\n\n```elixir\nOptimal.merge(schema1, schema2, annotate: \"Shared\")\n```\n\n---\n\n* `id`(`:int`) **Required**\n* `foo`(`:int`)\n\n#### Shared\n\n* `baz`(`:int`)\n* `bar`(`:int`)\n\n---","ref":"readme.html#merge-annotations"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}